/*********************************************************
 *********************************************************/

import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

import webwisdom.tango.*;
import netscape.javascript.JSObject;

/**
 * An interactive test of the Graphics.drawArc and Graphics.fillArc
 * routines. Can be run either as a standalone application by
 * typing "java ArcTest" or as an applet in the AppletViewer.
 */

public class testkimd extends Applet implements TControlListener, TDataListener {

	TAgent agent = null;
	private int channel = 90;

	boolean	isMaster = true;

	boolean inTango = true;

	public void init() {

		initThis();
		startThis();

	}

	public void initThis() {

		System.out.println("<testkimd> initThis()");

		if (inTango) {

			if ( agent == null ) {
				System.out.println("<testkimd> agent is null");
			}
			System.out.println("<testkimd> Before isMaster");
			isMaster = agent.isMaster();
			System.out.println("<testkimd> After isMaster");
			System.out.println("<testkimd> master : " + isMaster);
		}
	}

	public void commJava() {

		try {
			agent = new TAgent(new TLAgentApplet(this));
		}
		catch(TangoException e) {
			e.printStackTrace();
			System.out.println("<testkimd> agent is not proprely assigned");
		}

	}

	public void commJavaScript() {

		JSObject jsWin = JSObject.getWindow(this);
		Object[] args = new Object[1];
		args[0] = this;
		jsWin.call("appletReadyJS", args);
	}

	public void setTango(String arg) {
                if ( arg.equals("javaApplet") ) {
			commJava();
		}
		else if ( arg.equals("javaScript") ) {
			commJavaScript();
		}

		while ( agent == null ) {
			System.out.println("<testkimd> waiting for the agent to be assigned");
		}
		System.out.println("<testkimd> agent assigned");

		agent.addTDataListener(channel, this);
		agent.addTControlListener(this);
		isMaster = agent.isMaster();
	}

	public void setTango(String args[]) {

		try {
			agent = new TAgent(new TLAgentApplication(args));
		}
		catch(TangoException e) {
			e.printStackTrace();
			System.out.println("<testkimd> agent is not proprely assigned");
		}

		System.out.println("<testkimd> Application agent assigned");

		agent.addTDataListener(channel, this);
		System.out.println("<testkimd> Data added");

		agent.addTControlListener(this);
		System.out.println("<testkimd> Control added");

//		isMaster = agent.isMaster();
		System.out.println("<testkimd> Data Control added" + "channel : " + channel);
	}

	public void initTangoJS(TAgent a, Number ch, Number ma) {

		channel = ((Number) ch).intValue();

		if ( ((Number) ma).intValue() ==  0 ) {
			isMaster = true;
		}
		else {
			isMaster = false;
		}

		agent = a;
	}

	public void sendMessage(String send_data) {

		if (!inTango) {
			return;
		}

		System.out.println("<testkimd> send : " + send_data);
	}

	public void startThis() {
		System.out.println("<testkimd> startThis()");
	}

	public void stop() {
	}

	public void destroy() {
		if (agent != null) {
			agent.exit();
		}
		super.destroy();
	}

	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			System.exit(0);
		}
		return false;
	}

	public void receive(byte b[]) {


	}

	public void masterChanged(boolean isMaster, String masterName) {
	}

	public void participantJoined(String participantName) {

	}

	public void participantLeft(String participantName) {

	}

	public void audioRequested(boolean isREquested) {
	}

	public static void main(String args[]) {
		System.out.println("<testkimd> application start!");
		Frame f = new Frame("ArcTest");
		testkimd testKimd = new testkimd();

		try {
			System.out.println("<testkimd> args[0] : " + args[0]);
			testKimd.inTango = true;
		}
		catch (Exception e) {
			testKimd.inTango = false;
		}

		System.out.println("inTango : " + testKimd.inTango);

		if (testKimd.inTango) {
			testKimd.setTango(args);
		}

		testKimd.initThis();
		testKimd.startThis();
	}
}

